#include "psgd.h"

// O[oϐ
static u8 *g_songAddr[SONG_MAX];	// TEhf[^JnAhX
static u8 *g_curPos;				// ݉t̃AhX

static u8 g_defaultLen;				// ftHg
static u8 g_curLen;					// ݂̔(VBlankJE^[B0Ŏ̉)

// ֐錾(t@C[J)
void _PSGD_Start(u8 *);
void _PSGD_SetV(int, int);
void _PSGD_SetF(int, int);
int  _PSGD_DecodeData();

//
// hCo
//
void PSGD_Init()
{
	int i;
	
	for(i=0; i<SONG_MAX; i++)
	{
		g_songAddr[i] = 0;
	}
	
	g_curPos = 0;
	
	g_defaultLen = 10;
	g_curLen = 0;
	
	_PSGD_SetV(0, 0);
	_PSGD_SetV(1, 0);
	_PSGD_SetV(2, 0);
	_PSGD_SetV(3, 0);
}

//
// TEhf[^̊JnAhXhCoɐݒ肷
//
void PSGD_SetData(int songNo, u8 *addr)
{
	if(songNo < 0 || songNo > SONG_MAX)
	{
		return;
	}
	
	g_songAddr[songNo] = addr;
}

//
// wTEhf[^(songNoŎw)tJn
//
void PSGD_Play(int songNo)
{
	if(songNo < 0 || songNo > SONG_MAX)
	{
		return;
	}
	
	_PSGD_Start(g_songAddr[songNo]);
}

//
// (VBlankŌĂ)
//
void PSGD_PeriodicProc()
{
	if(g_curPos != 0)
	{
		if(g_curLen == 0)
		{
			// ݂̔0ɂȂÃf[^͂Ďs
			
			// R}hɂẮAt[ŕ̃R}hs
			while(_PSGD_DecodeData() != 0);
		}
		else
		{
			// ݂̔XV
			g_curLen = g_curLen - 1;
		}
	}
}

//
// wAhX̃f[^͂s
// return:
//   0: ͊B̃t[܂ŌĂяoKvȂB
//   1: ̃t[ōēxĂяoKv
int _PSGD_DecodeData()
{
	int retVal;
	u8 dat;
	u8 dat2;
	u8 dat3;
	
	// ̃f[^擾A|C^++
	dat = *g_curPos++;
	
	// TEhf[^
	switch(dat)
	{
		case CMD_VOL:
			// {[
			dat2 = *g_curPos++;
			_PSGD_SetV(0, dat2);
			retVal = 1;
			break;
		
		case CMD_TONE:
			// TONEl
			dat2 = *g_curPos++;		// H
			dat3 = *g_curPos++;		// L

			_PSGD_SetF(0, (int)((dat2<<8) | dat3));
			g_curLen = g_defaultLen;
			
			retVal = 0;
			break;

		case CMD_LEN:
			// 
			dat2 = *g_curPos++;
			g_defaultLen = dat2;
			retVal = 1;
			break;
		
		case CMD_END:
			// tI
			g_curPos = 0;
			_PSGD_SetV(0, 0);
			retVal = 0;
			break;
		
		default:
			// sȃTEhf[^
			g_curPos = 0;
			_PSGD_SetV(0, 0);
			retVal = 0;
			break;
	}

	return retVal;
}


//
// wAhX̃f[^tJn
//
void _PSGD_Start(u8 *addr)
{
	if(addr == 0)
	{
		return;
	}
	
	g_curPos = addr;
	g_curLen = 0;
}

//
// PSG: ChƂ̃{[ݒ
//
void _PSGD_SetV(int ch, int val)
{
    vu8 *p;
	int vol;

    p = (vu8 *)0xc00011;

	vol = 15 - val;

	*p = (vu8)(
		0x80 | 					// Latch
		((ch & 0x3) << 5) | 	// Channel
		0x10 |					// Type
		(vol & 0x0f)			// Data
	);
}

//
// PSG: ChƂ̏o͎gݒ
// 
//
void _PSGD_SetF(int ch, int val)
{
    vu8 *p;
	int freq;

    p = (vu8 *)0xc00011;

	freq = val & 0x3ff;

	*p = (vu8)(
		0x80 | 					// Latch
		((ch & 0x3) << 5) | 	// Channel
		0x00 |					// Type
		(freq & 0x0f)			// Data
	);

	*p = (vu8)(
		((freq & 0x3f0) >> 4) & 0xff			// Data
	);
}

